

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.15.8. highlight_full &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.15.9. highlight_html" href="highlight_html.html" />
    <link rel="prev" title="7.15.7. geo_in_rectangle" href="geo_in_rectangle.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/functions/highlight_full.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="highlight_html.html" title="7.15.9. highlight_html"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="geo_in_rectangle.html" title="7.15.7. geo_in_rectangle"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" accesskey="U"><span class="section-number">7.15. </span>Function</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.8. </span><code class="docutils literal notranslate"><span class="pre">highlight_full</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="highlight-full">
<h1><span class="section-number">7.15.8. </span><code class="docutils literal notranslate"><span class="pre">highlight_full</span></code><a class="headerlink" href="#highlight-full" title="Permalink to this headline">¶</a></h1>
<div class="versionadded">
<p><span class="versionmodified added">New in version 4.0.5.</span></p>
</div>
<div class="section" id="summary">
<h2><span class="section-number">7.15.8.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">highlight_full</span></code> tags target text. It can use to highlight the search
keyword. It can specify use/not use HTML escape, the normalizer name and
change the tag for each keyword.</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.15.8.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">highlight_full</span></code> has required parameter and optional parameter:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>highlight_full(column, normalizer_name, use_html_escape,
               keyword1, open_tag1, close_tag1,
               ...
               [keywordN, open_tagN, close_tagN])
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.15.8.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>Here are a schema definition and sample data to show usage.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Entries TABLE_NO_KEY
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Entries body COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Terms TABLE_PAT_KEY ShortText --default_tokenizer TokenBigram --normalizer NormalizerAuto
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Terms document_index COLUMN_INDEX|WITH_POSITION Entries body
# [[0, 1337566253.89858, 0.000355720520019531], true]
load --table Entries
[
{&quot;body&quot;: &quot;Mroonga is a ＭｙＳＱＬ storage engine based on Groonga. &lt;b&gt;Rroonga&lt;/b&gt; is a Ruby binding of Groonga.&quot;}
]
# [[0, 1337566253.89858, 0.000355720520019531], 1]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">highlight_full</span></code> can be used in only <code class="docutils literal notranslate"><span class="pre">--output_columns</span></code> in
<a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> before version 10.0.6 (exclusive).
However, it can be also used in <code class="docutils literal notranslate"><span class="pre">--output_columns</span></code> in
<a class="reference internal" href="../commands/logical_select.html"><span class="doc">logical_select</span></a> since version 10.0.6.</p>
<p><code class="docutils literal notranslate"><span class="pre">highlight_full</span></code> requires <a class="reference internal" href="../command/command_version.html"><span class="doc">Command version</span></a> 2
or later.</p>
<p>The following example uses HTML escape and normalzier is <code class="docutils literal notranslate"><span class="pre">NormalizeAuto</span></code>.
It specifies the tags <code class="docutils literal notranslate"><span class="pre">&lt;span</span> <span class="pre">class=&quot;keyword1&quot;&gt;</span></code> and <code class="docutils literal notranslate"><span class="pre">&lt;/span&gt;</span></code> of the
keyword <code class="docutils literal notranslate"><span class="pre">groonga</span></code>, and the tags <code class="docutils literal notranslate"><span class="pre">&lt;span</span> <span class="pre">class=&quot;keyword2&quot;&gt;</span></code> and <code class="docutils literal notranslate"><span class="pre">&lt;/span&gt;</span></code>
of the keyword <code class="docutils literal notranslate"><span class="pre">mysql</span></code>.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Entries --output_columns &#39;highlight_full(body, &quot;NormalizerAuto&quot;, true, &quot;Groonga&quot;, &quot;&lt;span class=\\&quot;keyword1\\&quot;&gt;&quot;, &quot;&lt;/span&gt;&quot;, &quot;mysql&quot;, &quot;&lt;span class=\\&quot;keyword2\\&quot;&gt;&quot;, &quot;&lt;/span&gt;&quot;)&#39; --command_version 2
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;highlight_full&quot;,
#           null
#         ]
#       ],
#       [
#         &quot;Mroonga is a &lt;span class=\&quot;keyword2\&quot;&gt;ＭｙＳＱＬ&lt;/span&gt; storage engine based on &lt;span class=\&quot;keyword1\&quot;&gt;Groonga&lt;/span&gt;. &amp;lt;b&amp;gt;Rroonga&amp;lt;/b&amp;gt; is a Ruby binding of &lt;span class=\&quot;keyword1\&quot;&gt;Groonga&lt;/span&gt;.&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>The text are scanned by the keywords for tagging after they are normalized
by <code class="docutils literal notranslate"><span class="pre">NormalizerAuto</span></code> normalizer.</p>
<p><code class="docutils literal notranslate"><span class="pre">--query</span> <span class="pre">&quot;groonga</span> <span class="pre">mysql&quot;</span></code> matches to the first record’s body.
<code class="docutils literal notranslate"><span class="pre">highight_full</span></code> surrounds the keywords <code class="docutils literal notranslate"><span class="pre">groonga</span></code> contained in the text
with <code class="docutils literal notranslate"><span class="pre">&lt;span</span> <span class="pre">class=&quot;keyword1&quot;&gt;</span></code> and <code class="docutils literal notranslate"><span class="pre">&lt;/span&gt;</span></code>, and the keywords <code class="docutils literal notranslate"><span class="pre">mysql</span></code>
contained in the text with with <code class="docutils literal notranslate"><span class="pre">&lt;span</span> <span class="pre">class=&quot;keyword2&quot;&gt;</span></code> and <code class="docutils literal notranslate"><span class="pre">&lt;/span&gt;</span></code>.</p>
<p>Special characters such as <code class="docutils literal notranslate"><span class="pre">&lt;</span></code> and <code class="docutils literal notranslate"><span class="pre">&gt;</span></code> are escapsed as <code class="docutils literal notranslate"><span class="pre">&amp;lt;</span></code> and
<code class="docutils literal notranslate"><span class="pre">&amp;gt;</span></code>.</p>
<p>You can specify string literal instead of column.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Entries --output_columns &#39;highlight_full(&quot;Groonga is very fast fulltext search engine.&quot;, &quot;NormalizerAuto&quot;, true, &quot;Groonga&quot;, &quot;&lt;span class=\\&quot;keyword1\\&quot;&gt;&quot;, &quot;&lt;/span&gt;&quot;, &quot;mysql&quot;, &quot;&lt;span class=\\&quot;keyword2\\&quot;&gt;&quot;, &quot;&lt;/span&gt;&quot;)&#39; --command_version 2 --match_columns body --query &quot;groonga&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;highlight_full&quot;,
#           null
#         ]
#       ],
#       [
#         &quot;&lt;span class=\&quot;keyword1\&quot;&gt;Groonga&lt;/span&gt; is very fast fulltext search engine.&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.15.8.4. </span>Parameters<a class="headerlink" href="#parameters" title="Permalink to this headline">¶</a></h2>
<p>There are three required parameters, <code class="docutils literal notranslate"><span class="pre">column</span></code>, <code class="docutils literal notranslate"><span class="pre">normalizer_name</span></code> and <code class="docutils literal notranslate"><span class="pre">use_html_escape</span></code>.
There are three or over optional parameters, <code class="docutils literal notranslate"><span class="pre">keywordN</span></code>, <code class="docutils literal notranslate"><span class="pre">open_tagN</span></code> and <code class="docutils literal notranslate"><span class="pre">end_tagN</span></code>.</p>
<div class="section" id="column">
<h3><span class="section-number">7.15.8.4.1. </span><code class="docutils literal notranslate"><span class="pre">column</span></code><a class="headerlink" href="#column" title="Permalink to this headline">¶</a></h3>
<p>Specifies a column of the table.</p>
</div>
<div class="section" id="normalizer-name">
<h3><span class="section-number">7.15.8.4.2. </span><code class="docutils literal notranslate"><span class="pre">normalizer_name</span></code><a class="headerlink" href="#normalizer-name" title="Permalink to this headline">¶</a></h3>
<p>Specifies a normalizer name.</p>
</div>
<div class="section" id="use-html-escape">
<h3><span class="section-number">7.15.8.4.3. </span><code class="docutils literal notranslate"><span class="pre">use_html_escape</span></code><a class="headerlink" href="#use-html-escape" title="Permalink to this headline">¶</a></h3>
<p>Specifies use or not use HTML escape. If it is <code class="docutils literal notranslate"><span class="pre">true</span></code> , use HTML escape.
If it is <code class="docutils literal notranslate"><span class="pre">false</span></code> , not use HTML escape.</p>
</div>
<div class="section" id="keywordn">
<h3><span class="section-number">7.15.8.4.4. </span><code class="docutils literal notranslate"><span class="pre">keywordN</span></code><a class="headerlink" href="#keywordn" title="Permalink to this headline">¶</a></h3>
<p>Specifies a keyword for tagging.
You can specify multiple keywords for each three arguments.</p>
</div>
<div class="section" id="open-tagn">
<h3><span class="section-number">7.15.8.4.5. </span><code class="docutils literal notranslate"><span class="pre">open_tagN</span></code><a class="headerlink" href="#open-tagn" title="Permalink to this headline">¶</a></h3>
<p>Specifies a open tag.
You can specify multiple open tags for each three arguments.</p>
</div>
<div class="section" id="close-tagn">
<h3><span class="section-number">7.15.8.4.6. </span><code class="docutils literal notranslate"><span class="pre">close_tagN</span></code><a class="headerlink" href="#close-tagn" title="Permalink to this headline">¶</a></h3>
<p>Specifies a close tag.
You can specify multiple close tags for each three arguments.</p>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.15.8.5. </span>Return value<a class="headerlink" href="#return-value" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">highlight_full</span></code> returns a tagged string or <code class="docutils literal notranslate"><span class="pre">null</span></code>. If
<code class="docutils literal notranslate"><span class="pre">highlight_full</span></code> can’t find any keywords, it returns <code class="docutils literal notranslate"><span class="pre">null</span></code>.</p>
</div>
<div class="section" id="see-also">
<h2><span class="section-number">7.15.8.6. </span>See also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li><p><a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a></p></li>
<li><p><a class="reference internal" href="../commands/logical_select.html"><span class="doc">logical_select</span></a></p></li>
<li><p><a class="reference internal" href="highlight_html.html"><span class="doc">highlight_html</span></a></p></li>
</ul>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.15.8. <code class="docutils literal notranslate"><span class="pre">highlight_full</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.15.8.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.15.8.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.15.8.3. Usage</a></li>
<li><a class="reference internal" href="#parameters">7.15.8.4. Parameters</a><ul>
<li><a class="reference internal" href="#column">7.15.8.4.1. <code class="docutils literal notranslate"><span class="pre">column</span></code></a></li>
<li><a class="reference internal" href="#normalizer-name">7.15.8.4.2. <code class="docutils literal notranslate"><span class="pre">normalizer_name</span></code></a></li>
<li><a class="reference internal" href="#use-html-escape">7.15.8.4.3. <code class="docutils literal notranslate"><span class="pre">use_html_escape</span></code></a></li>
<li><a class="reference internal" href="#keywordn">7.15.8.4.4. <code class="docutils literal notranslate"><span class="pre">keywordN</span></code></a></li>
<li><a class="reference internal" href="#open-tagn">7.15.8.4.5. <code class="docutils literal notranslate"><span class="pre">open_tagN</span></code></a></li>
<li><a class="reference internal" href="#close-tagn">7.15.8.4.6. <code class="docutils literal notranslate"><span class="pre">close_tagN</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.15.8.5. Return value</a></li>
<li><a class="reference internal" href="#see-also">7.15.8.6. See also</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="geo_in_rectangle.html"
                        title="previous chapter"><span class="section-number">7.15.7. </span>geo_in_rectangle</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="highlight_html.html"
                        title="next chapter"><span class="section-number">7.15.9. </span><code class="docutils literal notranslate"><span class="pre">highlight_html</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="highlight_html.html" title="7.15.9. highlight_html"
             >next</a> |</li>
        <li class="right" >
          <a href="geo_in_rectangle.html" title="7.15.7. geo_in_rectangle"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" ><span class="section-number">7.15. </span>Function</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.8. </span><code class="docutils literal notranslate"><span class="pre">highlight_full</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>